/*
 * ReadProcessor.cpp
 *
 *  Created on: Feb 5, 2016
 *      Author: vlegrand
 */

#include <stdlib.h>
#include "ReadProcessor.h"



unsigned long ReadProcessor::nucleoToNumberWrap(char s) {
    if (s=='N') n=k;
    n--;
    return nucleoToNumber(s);
}


#include <iostream>

unsigned long ReadProcessor::kMerToNumber(char * k_m,unsigned long * p_prev) {
    unsigned long nbr=0;
    unsigned long c;
    if (p_prev==NULL) { // first k_mer conversion
        int i;
        for (i=0;i<k;i++) {
            /*try {
                c=nucleoToNumberWrap(k_m[i]); // do not catch exception for the moment (not until I have checked it doesn't slow down execution). If nucleoToNumber returns -1, program will simply crash
            }
            catch (int e) {
                std::cout<<"couldn't convert nucleotide: "<<k_m[i]<<"to number.\n";
                exit(-1);
            } */ // this slightly decreases the performances
            c=nucleoToNumberWrap(k_m[i]); // do not catch exception for the moment. If nucleoToNumber throws -1 and there is no catch clause for it, the terminate() function will be called automatically. Anyway, there's not munch we can do if it returns -1.
            nbr=nbr<<2;
            nbr=nbr|c;
        }
    } else {
        nbr=*p_prev;
        c=nucleoToNumberWrap(k_m[k-1]);
        nbr=nbr<<2;
        nbr=nbr&mask_kMer;
        nbr=nbr|c;
    }
    return nbr;
}

// Tried to inline this but it is sligntly slower. Put it back not inline.
unsigned long ReadProcessor::kMerToNumberReverse(char * k_m,unsigned long * p_prev) {
    unsigned long nbr=0;
    unsigned long c;
    if (p_prev==NULL) { // first k_mer conversion
        int i;
        for (i=k;i>0;i--) {
            c=nucleoToNumberReverse(k_m[i-1],i);
            nbr=nbr|c;
        }
    } else {
        nbr=*p_prev;
        c=nucleoToNumberReverse(k_m[k-1],k);
        nbr=nbr>>2;
        nbr=nbr|c;
    }
    return nbr;
}

void ReadProcessor::getKMerNumbers(char * dnaStr,int l,std::vector<unsigned long>& my_vect) { // See simple_test.cpp and results. benchmark showed that std::vector is very slightly faster than C array and doesn't require more memory in our case. So, I am using it since it makes code simpler.
    int i;
    unsigned long num;
    unsigned long num_rev;
    unsigned long * p_prev=NULL;
    unsigned long * p_prev_rev=NULL;
    char * p_char=dnaStr;
    int nb_k_m=l-k+1;
    for (i=0; i<nb_k_m;i++) {
        num=kMerToNumber(p_char,p_prev);
        num_rev=kMerToNumberReverse(p_char,p_prev_rev);
        if (n<0) {
            (num<num_rev)?my_vect.push_back(num_rev):my_vect.push_back(num); // finding a k-mer is equivalent to finding its reverse complement; as numeric values for k-mers are unique, just take into account the biggest of the 2.
        }
        p_char++;
        p_prev=&num;
        p_prev_rev=&num_rev;
    }
}
